local CutsceneCoroutine_0;
local CutsceneCoroutine_1;
local CutsceneCoroutine_2;
local CutsceneCoroutine_3;
local CutsceneCoroutine_4;

function Cutscene_0()

	--Yaw Camera
	getglobal("BlackBorderFrame"):Show();
	CurMainPlayer:setViewMode(1);
	DebugMgr:switchCameraControlType(4);
	SetCameraTransform(6000, 16000, 9000, -120, 90, 0);
	LerpCamera(3600, 10204, 3019,  0, -10, 0, 6, 0.2);
	Log("Translate camera");

	StartTimer(0);
	while (GetTimer(0) < 6)
	do
		coroutine.yield(1);
	end
	StopTimer(0);

	local npcId = GetNoviceGuideNpcId();
	NpcActor = CurWorld:getActorMgr():spawnMonster(3400, 9100, 2800, npcId, 290);
	table.insert(t_ItemActor, {id=npcId, actor=NpcActor});

	-- Lerp Camera to player
	LerpCamera(4010, 9200, 2200,  -12, -20, 0, 1, 0.1);
	--RotateActor(CurMainPlayer,10);

	StartTimer(0);
	while (GetTimer(0) < 3)
	do
		coroutine.yield(1);
	end
	StopTimer(0);

	-- Lerp Camera to fps
	LerpCamera(3950, 9200, 2500,  0, -20, 0, 0.8, 0.5);
	--RotateActor(CurMainPlayer,10);

	StartTimer(0);
	while (GetTimer(0) < 2)
	do
		coroutine.yield(1);
	end
	StopTimer(0);

	DebugMgr:switchCameraControlType(0);
	CurMainPlayer:setViewMode(0);
	
	StartTimer(0);
	while (GetTimer(0) < 0.5)
	do
		coroutine.yield(1);
	end
	StopTimer(0);

	--Start talk
	UpdateNoviceStoryFrame(1);
	getglobal("BlackBorderFrame"):Hide();
	--ImplementNoviceGuide();

	Log("Wait finished");
	return 0;
end


function Cutscene_1()
	MoveActor(NpcActor, 2526, 9370, 3018, 1);
	StartTimer(0);
	while (GetTimer(0) < 3)
	do
		coroutine.yield(1);
	end
	StopTimer(0);

	MoveActor(NpcActor, 1437, 9270, 3024, 1);

	StartTimer(0);
	while (GetTimer(0) < 2)
	do
		coroutine.yield(1);
	end
	StopTimer(0);

	MoveActor(NpcActor, 1514, 9270, 3388, 1);
	RotateActor(NpcActor,0);

	return 0;
end

function Cutscene_2()
	MoveActor(NpcActor, 793, 9270, 3126, 1);
	StartTimer(1);
	while (GetTimer(1) < 1.5)
	do
		coroutine.yield(1);
	end
	StopTimer(1);
	
	ImplementNoviceGuide();
	MoveActor(NpcActor, 232, 9270, 3339, 1);
	StartTimer(1);
	while (GetTimer(1) < 1.5)
	do
		coroutine.yield(1);
	end
	StopTimer(1);

	MoveActor(NpcActor, -98, 9270, 2623, 1);

	StartTimer(1);
	while (GetTimer(1) < 1.5)
	do
		coroutine.yield(1);
	end
	StopTimer(1);

	RotateActor(NpcActor,190);

	return 0;
end

function Cutscene_3()
	DisableInput();
	RotatePlayerToYaw(-80, 2);
	EnableInput();

	StartTimer(1);
	while (GetTimer(1) < 2)
	do
		coroutine.yield(1);
	end
	StopTimer(1);

	UpdateNoviceStoryFrame(4);
		
	return 0;
end

--[[
--Look at the beautiful scene!!
cutscene_0 = coroutine.create(
	function()
		--Yaw Camera
		DebugMgr:switchCameraControlType(4);
		SetCameraTransform(3970, 10204, 3019, -12, 53, 0);
		LerpCamera(3970, 10204, 3019,  -12, -10, 0, 1, 0.2);
		Log("Translate camera");

		StartTimer(0);
		while (GetTimer(0) < 4)
		do
			coroutine.yield(1);
		end
		StopTimer(0);

		local npcId = GetNoviceGuideNpcId();
		NpcActor = CurWorld:getActorMgr():spawnMonster(3400, 9100, 2800, npcId, 290);
		table.insert(t_ItemActor, {id=npcId, actor=NpcActor});

		-- Lerp to Camera pos
		LerpCamera(3900, 9200, 2500,  -12, -10, 0, 1, 0.5);
		RotateActor(CurMainPlayer,10);

		StartTimer(0);
		while (GetTimer(0) < 3)
		do
			coroutine.yield(1);
		end
		StopTimer(0);
		DebugMgr:switchCameraControlType(0);
		CurMainPlayer:setViewMode(0);

		StartTimer(0);
		while (GetTimer(0) < 0.5)
		do
			coroutine.yield(1);
		end
		StopTimer(0);

		--Start talk
		UpdateNoviceStoryFrame(1);

		Log("Wait finished");
		return 0;
	end
)


--Follow me to get diamond
cutscene_1 = coroutine.create(
	function()
		--local npcId = GetNoviceGuideNpcId();
		--local NpcActor = SpawnNPC(npcId,3500, 9100, 2900, 120);
		MoveActor(NpcActor, 2526, 9370, 3018, 1);

		StartTimer(0);
		while (GetTimer(0) < 3)
		do
			coroutine.yield(1);
		end
		StopTimer(0);

		MoveActor(NpcActor, 1437, 9270, 3024, 1);

		StartTimer(0);
		while (GetTimer(0) < 2)
		do
			coroutine.yield(1);
		end
		StopTimer(0);

		MoveActor(NpcActor, 1514, 9270, 3388, 1);
		RotateActor(NpcActor,0);

		return 0;
	end
)


--Follow me to get apple
cutscene_2 = coroutine.create(
	function()
		MoveActor(NpcActor, 793, 9270, 3126, 1);
		StartTimer(1);
		while (GetTimer(1) < 1.5)
		do
			coroutine.yield(1);
		end
		StopTimer(1);

		MoveActor(NpcActor, 232, 9270, 3339, 1);
		StartTimer(1);
		while (GetTimer(1) < 1.5)
		do
			coroutine.yield(1);
		end
		StopTimer(1);

		MoveActor(NpcActor, -98, 9270, 2623, 1);

		StartTimer(1);
		while (GetTimer(1) < 1.5)
		do
			coroutine.yield(1);
		end
		StopTimer(1);

		RotateActor(NpcActor,190);

		return 0;
	end
)

--Look at nini
cutscene_3 = coroutine.create(
	function()
		DisableInput();
		RotatePlayerToYaw(10, 2);
		EnableInput();

		StartTimer(1);
		while (GetTimer(1) < 2)
		do
			coroutine.yield(1);
		end
		StopTimer(1);

		UpdateNoviceStoryFrame(4);
		return 0;
	end
)


cutscene_backUp = coroutine.create(
	function()

		local npcId = GetNoviceGuideNpcId();
		local NpcActor = SpawnNPC(npcId,3500, 9100, 2900, 120);
		--CutSceneMgr:moveMob(NpcActor, 3855, 9100, 2730, 1);
		MoveActor(NpcActor, 3855, 9100, 2730, 1);

		--local SEQ_WALK = 1;
		--NpcActor:setAIActive(false);
		--NpcActor:getBody():setCurAnim(SEQ_WALK, 0);

		Log("spawnActor");
		table.insert(cutscene_ItemActor, {id=npcId, actor=NpcActor});
		
		DebugMgr:switchCameraControlType(4);
		TranslateCamera(3901, 9242, 2466, -0.8, -76, 0, 200, 0.8);
		Log("Translate camera");

		StartTimer(0);
		--CutSceneMgr:startTimer(0);
		Log("startTimer");
		while (GetTimer(0) < 2)
		do
			coroutine.yield(1);
		end
		StopTimer(0);

		getglobal("GuideOperateFrame"):Hide();
		ShowTip(0, GetS(3306));
		--PlaySound(1);
		--SetOperateContent(GetS(3309));
		Log("Wait finished");
		return 0;
	end
)
]]

function RunCutscene(id)
	if id == 0 then
      	CutsceneCoroutine_0 = coroutine.create(Cutscene_0);
		CutSceneMgr:playCutScene(0);
    elseif id == 1 then
      CutsceneCoroutine_1 = coroutine.create(Cutscene_1);
		CutSceneMgr:playCutScene(1);
    elseif id == 2 then
      CutsceneCoroutine_2 = coroutine.create(Cutscene_2);
      CutSceneMgr:playCutScene(2);
    elseif id == 3 then
      CutsceneCoroutine_3 = coroutine.create(Cutscene_3);
      CutSceneMgr:playCutScene(3);
    elseif id == 4 then
      CutsceneCoroutine_4 = coroutine.create(Cutscene_4);
      CutSceneMgr:playCutScene(4);
    end
end


function TickCutscene(id)
	if id == 0 then
      return coroutine.resume(CutsceneCoroutine_0);
    elseif id == 1 then
      return coroutine.resume(CutsceneCoroutine_1);
    elseif id == 2 then
      return coroutine.resume(CutsceneCoroutine_2);
    elseif id == 3 then
      return coroutine.resume(CutsceneCoroutine_3);
    elseif id == 4 then
      return coroutine.resume(CutsceneCoroutine_4);
    end
end