

function OpenWindowOnBlock(blockid)
	if CurWorld:isCreativeMode() then return end

	local frame = nil;
	if blockid == 800 then
		frame = getglobal("CraftingTableFrame");
	elseif blockid == 833 then
		frame = getglobal("EnchantFrame");
		Enchant_Type = 2;
	elseif blockid == 824 then
		frame = getglobal("RepairFrame");
	end

	if frame ~= nil then
		UIFrameMgr:frameShow(frame);
		--ClientCurGame:setOperateUI(true);		
	end
end

--̨
function CraftingTable_OnClick(x, y, z, toolid)
	if not CurWorld:isCreativeMode() then
		return true;
	end
	return true;
end

--ħ̨
function EnchantTable_OnClick(x, y, z, toolid)
	if not CurWorld:isCreativeMode() then
		enchantframe = getglobal("EnchantFrame");

		Enchant_Type = 2;
		enchantframe:Show();
		--ClientCurGame:setOperateUI(true);
		return true;
	end
	return true;
end

--
function Anvil_OnClick(x, y, z, toolid)
	if not CurWorld:isCreativeMode() then
		repairframe = getglobal("RepairFrame");

		UIFrameMgr:frameShow(repairframe);
	--	repairframe:Show();
		--ClientCurGame:setOperateUI(true);
--[[
		bdata = CurWorld:getBlockData(x, y, z)
		stage = math.floor(bdata/4)
		dir = bdata - stage*4

		if stage > 2 then
			CurWorld:setBlockAll(x, y, z, 0, 0)
		else
			stage = stage + 1
			CurWorld:setBlockData(x, y, z, stage*4 + dir);
		end
]]
		return true;
	end
	return true;
end

--¯
function Furnace_OnClick(x, y, z, toolid)
--[[
	if not CurWorld:isCreativeMode() then
		CurAttachedFurnace = CurWorld:getContainerMgr():getFurnace(x,y,z)
		ClientBackpack:attachContainer(CurAttachedFurnace)

		local furnaceframe = getglobal("FurnaceFrame");
		UIFrameMgr:frameShow(furnaceframe);

		ClientCurGame:setOperateUI(true);
		return true;
	end
	return true;
	]]
	return false;
end

--
function StorageBox_OnClick(x, y, z, toolid)
	return false;
end

--
function TreasureBox_OnClick(x, y, z, toolid)
	if not CurWorld:isCreativeMode() then
		blockdata = CurWorld:getBlockData(x,y,z)
		if blockdata >= 4 then return true end --Ѿ
		
		dir = blockdata%4
		
		CurAttachedStorage = CurWorld:getContainerMgr():getStorageBox(x,y,z)
		CurAttachedStorage:append(nil)

		ClientBackpack:attachContainer(CurAttachedStorage)
		
		UIFrameMgr:frameShow(StorageBoxFrame);
		--ClientCurGame:setOperateUI(true)
		return true
	end
	return true
end
