
SelectRoleIndex = -1; 
RoleNickName = "";	
--------------------------------------------------------SelectRoleFrame--------------------------------------------
--[[
local t_RoleBindId = { 2, 4, 3, 5, 6 };
local t_PlayerIndices = { 
				{index=1, roleName="player02xiaonanhai"},
				{index=0, roleName="player01dashu"},
				{index=7, roleName="player08dama"},
				{index=6, roleName="player07xiaonvhai"},
				{index=5, roleName="player06xionghaizi"},
			};
]]

local t_RoleBindId = {2, 3};
local t_PlayerIndices = { 
				{index=1, roleName="player02xiaonanhai"},
				{index=7, roleName="player08xiaonvhai"},
			};
local t_RoleInfo ={
			{name="巴扎", desc="    原名巴扎·黑，从小生活在原始部落，拥有较强的生存能力", effectId=1103},
			{name="妮妮", desc="	妮妮是巴扎的妹妹，心地善良，喜欢大自然的花花草草", effectId=1104},	
		}

function SelectRoleFrame_OnLoad()
end

function SelectRoleFrame_OnEvent()
end

function SelectRoleFrame_OnShow()
	if IsFirstLogin then
		getglobal("InputRoleNameFrame"):Show();		
	end

	local SelectRoleView = getglobal("SelectRoleView")
	SelectRoleView:setBackground("ui/models/selrole1.omod");
	SelectRoleView:addBackgroundEffect("particles/1100.ent", 0, 0, 0);

	SelectRoleView:setCameraLookAt(0, 216, -1200, 0, 127, 0);
	SelectRoleView:setCameraFov(30);
end

local CurSelectIndex = -1;
function SelectRoleFrame_OnMouseDown()
	local SelectRoleView = getglobal("SelectRoleView")
	local index = SelectRoleView:getActorOnScreenPoint(GetCursorPosX(),GetCursorPosY());
	if index ~= -1 and RoleNickName ~= "" then
		CurSelectIndex = index;
		SelectRoleView:setActorScale(0.95, 0.95, 0.95, CurSelectIndex);	
	end
end

function SelectRoleFrame_OnMouseUp()
	if CurSelectIndex ~= -1 and RoleNickName ~= "" then
		local SelectRoleView = getglobal("SelectRoleView")

		if SelectRoleIndex ~= -1 then
			SelectRoleView:bindActorToAnchor(t_RoleBindId[SelectRoleIndex+1], SelectRoleIndex);
			SelectRoleView:playActorAnim(100100, SelectRoleIndex);
			SelectRoleView:setActorCollide(true, SelectRoleIndex);
			SelectRoleView:setActorScale(1.0, 1.0, 1.0, SelectRoleIndex);
			SelectRoleView:stopEffect(t_RoleInfo[SelectRoleIndex+1].effectId, SelectRoleIndex);
		end
		
		SelectRoleIndex = CurSelectIndex;
		SelectRoleView:bindActorToAnchor(1, SelectRoleIndex);
		SelectRoleView:playActorAnim(100108, SelectRoleIndex);
		SelectRoleView:setActorCollide(false, SelectRoleIndex);

		SelectRoleView:setActorScale(1.4, 1.4, 1.4, SelectRoleIndex);
		CurSelectIndex = -1;

		SelectRoleView:playEffect(t_RoleInfo[SelectRoleIndex+1].effectId, SelectRoleIndex);
		if not getglobal("SelectRoleFrameNextBtn"):IsShown() then
			getglobal("SelectRoleFrameNextBtn"):Show();
		end

		if not getglobal("SelectRoleFrameNameBkg"):IsShown() then
			getglobal("SelectRoleFrameNameBkg"):Show();
		end
		getglobal("SelectRoleFrameName"):SetText(t_RoleInfo[SelectRoleIndex+1].name);

		if not getglobal("SelectRoleFrameDescBkg"):IsShown() then
			getglobal("SelectRoleFrameDescBkg"):Show();
		end

		getglobal("SelectRoleFrameDescName"):SetText(t_RoleInfo[SelectRoleIndex+1].name..":");
		getglobal("SelectRoleFrameDesc"):SetText(t_RoleInfo[SelectRoleIndex+1].desc, 255, 255, 255);
		
		if getglobal("GuideTipsFrame"):IsShown() then
			getglobal("GuideTipsFrame"):Hide();
		end
	end
	
end

function SelectRoleFrame_OnHide()
	local SelectRoleView = getglobal("SelectRoleView")
	if SelectRoleIndex ~= -1 then 
		SelectRoleView:setActorScale(1.0, 1.0, 1.0, SelectRoleIndex);
		SelectRoleView:stopEffect(t_RoleInfo[SelectRoleIndex+1].effectId, SelectRoleIndex);
	end
end

function SelectRoleFrameNextBtn_OnClick()
	if SelectRoleIndex == -1 then
		ShowGameTips(DefMgr:getStringDef(89), 3);
		return;
	end

	if not AccountManager:getNoviceGuideState("selectrole") then
		SetGuideTipsInfo(-260, 65, 1, DefMgr:getStringDef(87));

		MessageBox(6, DefMgr:getStringDef(91));
		getglobal("MessageBoxFrame"):SetClientString("进入教学");
		getglobal("GuideGrayBkgFrame"):Show();
		getglobal("SelectRoleFrameNextBtn"):Hide();
		return;	
	end
	EnterLobby();
end

function EnterLobby()
	if AccountManager:requestModifyRole(RoleNickName, t_PlayerIndices[SelectRoleIndex+1].index+1) then
		if not AccountManager:getNoviceGuideState("selectrole") then
			AccountManager:setNoviceGuideState("selectrole", true);
		end

		if not AccountManager:getNoviceGuideState("noviceteach") then
			AccountManager:setNoviceGuideState("noviceteach", true);
		end

		getglobal("SelectRoleFrame"):Hide();
		getglobal("BackgroundFrame"):Show();
		getglobal("LobbyFrame"):Show();
		getglobal("LobbyFrameArchiveFrame"):Show();

		ClientMgr:statisticsGameChooseRole(t_PlayerIndices[SelectRoleIndex+1].roleName);		
	else
	end
end

function SelectRoleFrameSkipNextBtn_OnClick()
	if AccountManager:requestModifyRole(RoleNickName, t_PlayerIndices[SelectRoleIndex+1].index+1) then
		getglobal("SelectRoleFrame"):Hide();
		getglobal("LoadingFrame"):Show();
		ClientMgr:statisticsGameChooseRole(t_PlayerIndices[SelectRoleIndex+1].roleName);

		if not AccountManager:getNoviceGuideState("selectrole") then
			AccountManager:setNoviceGuideState("selectrole", true);
		end
		
		AccountManager:requestEnterWorld(NewbieWorldId);
	
		ClientMgr:statisticsGameEvent("EnterSurviveWNum");
	end
end
--[[
function SelectRoleFrameSkipNextBtn_OnClick()
	if AccountManager:requestModifyRole(RoleNickName, t_PlayerIndices[SelectRoleIndex+1].index) then
		SelectRoleFrame:Hide();
		LoadingFrame:Show();
		ClientMgr:statisticsGameChooseRole(t_PlayerIndices[SelectRoleIndex+1].roleName);
		if AccountManager:requestCreateWorld(0, RoleNickName..DefMgr:getStringDef(59), 1, "", AccountManager:getRoleModel()) then
			ClientMgr:statisticsGameEvent("SurvivalWorld");	
			ClientMgr:statisticsGameEvent("EnterSurviveWNum");
		end

		if not AccountManager:getNoviceGuideState("selectrole") then
			AccountManager:setNoviceGuideState("selectrole", true);
		end
	end
end
]]

---------------------------------------------------InputRoleNameFrame-----------------------------------------------
function InputRoleNameFrame_OnShow()
	InputRoleNameFrameRandomBtn_OnClick();
end

function InputRoleNameFrameOkBtn_OnClick()
	local InputRoleNameFrameNameEdit = getglobal("InputRoleNameFrameNameEdit")
	if InputRoleNameFrameNameEdit:GetText() == "" then
		--提示角色名不能为空
		ShowGameTips(DefMgr:getStringDef(45), 3)
		return;
	end
	if not AccountManager:requestCheckNickname(InputRoleNameFrameNameEdit:GetText()) then
		--提示角色名已存在
		ShowGameTips(DefMgr:getStringDef(46), 3)
		return;
	end
	RoleNickName = InputRoleNameFrameNameEdit:GetText();
	getglobal("InputRoleNameFrame"):Hide();

	local SelectRoleView = getglobal("SelectRoleView")
	for i=1, 2 do
		local player = BuddyManager:getSelectRole(t_PlayerIndices[i].index);
		player:attachUIModelView(SelectRoleView, i-1);
		SelectRoleView:bindActorToAnchor(t_RoleBindId[i], i-1);
		SelectRoleView:playActorAnim(100100,i-1);
	end

	SelectRoleView:setCameraLookAt(0, 216, -1200, 0, 127, 0);
	SelectRoleView:setCameraFov(30);

	if not AccountManager:getNoviceGuideState("selectrole") then
		SetGuideTipsInfo(-260, 65, 1, DefMgr:getStringDef(88));	
	end
end

function InputRoleNameFrameRandomBtn_OnClick()
	local nickname = DefMgr:getRandomName(0)
	if not ClientCurGame:requestCheckNickname(nickname) then
		nickname = nickname..(math.random(1,999))
	end
	getglobal("InputRoleNameFrameNameEdit"):SetText(nickname)
end